private import hell2;
private import sysinfo;

/**
 * メッセージ
 */
class Message
{
public:
	enum
	{
		STATE_NONE,
		STATE_COMBO,
		STATE_REFLECT,
		STATE_HUNGRY,
		STATE_THUNDER,
		STATE_NUCLEAR,
		STATE_LOVE,
		STATE_GO,
		STATE_NASU,
	};
	float x;
	float y;
	float vx;
	float vy;
	int timer;
	int state;
	int param;
	int param2;
public:
	this()
	{
		x  = 0f; y  = 0f;
		vx = 0f; vy = 0f;
	}
	void init()
	{
		timer = 0;
		state = STATE_NONE;
	}
	void beginReflect(int val)
	{
		param  = val;
		state  = STATE_REFLECT;
		timer  = 60;
		x      = -64;
		y      = GH.HEIGHT;
		vx     = 4;
		vy     = -4;
		param2 = 0;
		if(val >= 100)
		{
			if(Hell_randint(0, 3) == 0)
			{
				param2 = 1;
			}
		}
	}
	void beginCombo(int rate)
	{
		param  = rate;
		state  = STATE_COMBO;
		timer  = 60;
		x      = -64;
		y      = GH.HEIGHT;
		vx     = 4;
		vy     = -4;
		param2 = 0;
		if(rate >= 32)
		{
			if(Hell_randint(0, 3) == 0)
			{
				param2 = 1;
			}
		}
	}
	void beginSomething()
	{
		if(state != STATE_NONE) return;
		timer  = 60;
		x      = -64;
		y      = GH.HEIGHT;
		vx     = 4;
		vy     = -4;
		switch(Hell_randint(0, 5))
		{
		case 0:
			state = STATE_HUNGRY;
			break;
		case 1:
			state = STATE_THUNDER;
			break;
		case 2:
			state = STATE_NUCLEAR;
			break;
		case 3:
			state = STATE_LOVE;
			break;
		case 4:
			state = STATE_GO;
			break;
		case 5:
			state = STATE_NASU;
			break;
		default:
			break;
		}
	}
	void update()
	{
		switch(state)
		{
		case STATE_THUNDER:
		case STATE_HUNGRY:
		case STATE_NUCLEAR:
		case STATE_LOVE:
		case STATE_GO:
		case STATE_NASU:
		case STATE_COMBO:
		case STATE_REFLECT:
			timer--;
			if(timer > 44)
			{
				x += vx; y += vy;
			}
			if(timer < 12)
			{
				x -= vx*2; y -= vy*2;
			}
			if(timer < 1) state = STATE_NONE;
			break;
		default:
			if(Hell_randint(0, 6000) == 0)
			{
				beginSomething();
			}
			break;
		}
	}
	void draw()
	{
		switch(state)
		{
		case STATE_THUNDER:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawThunder(x, y-48);
			break;
		case STATE_HUNGRY:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawHungry(x, y-48);
			break;
		case STATE_NUCLEAR:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawNuclear(x+64, y, timer*6);
			break;
		case STATE_LOVE:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawLove(x+64, y, timer*6);
			break;
		case STATE_GO:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawGo(x+64, y, timer*6);
			break;
		case STATE_NASU:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			drawOmega(x, y);
			drawNasu(x+64, y, timer*6);
			break;
		case STATE_COMBO:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			if(param >= 16) drawOmega2(x, y);
			else            drawOmega(x, y);
			if(param2 == 1)
			{
				drawShout(x, y-48);
			}
			else
			{
				drawBalloon(x, y-48);
				Hell_drawFontEx(cast(int)x+30, cast(int)y+10-48, .7f, 0xff, 0xff, 0xff, 0xff, "x%d", param);
			}
			break;
		case STATE_REFLECT:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			if(param >= 100) drawOmega2(x, y);
			else             drawOmega(x, y);
			if(param2 == 1)
			{
				drawShout(x, y-48);
			}
			else
			{
				drawBalloon(x, y-48);
				Hell_drawFontEx(cast(int)x+30, cast(int)y+10-48, .7f, 0xa0, 0xff, 0xa0, 0xff, "%d", param);
			}
			break;
		default:
			break;
		}
	}
	void drawShout(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 128, 64, 128, 64);
	}
	void drawHungry(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 0, 64, 128, 64);
	}
	void drawThunder(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 0, 128, 128, 64);
	}
	void drawBalloon(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 128, 0, 128, 64);
	}
	void drawOmega(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 192, 192, 64, 64);
	}
	void drawOmega2(float px, float py)
	{
		Hell_drawTexture("tama", px, py, 128, 128, 128, 128);
	}
	void drawNuclear(float px, float py, int t)
	{
		Hell_drawTexture("tama", px, py, 64, 0, 64, 64, 1, 1, t%360);
	}
	void drawLove(float px, float py, int t)
	{
		Hell_drawTexture("tama", px, py, 0, 192, 64, 64, 1, 1, t%360);
	}
	void drawGo(float px, float py, int t)
	{
		Hell_drawTexture("tama", px, py, 0, 0, 64, 64, 1, 1, t%360);
	}
	void drawNasu(float px, float py, int t)
	{
		Hell_drawTexture("tama", px, py, 128, 192, 64, 64, 1, 1, t%360);
	}
}
